require "tk"
#     ()
module TkDrawer
  #    
  def TkDrawer.create
    CANVAS.pack{padx 5; pady 5}; Thread.new{Tk.mainloop}
  end
  #       
  def TkDrawer.clean 
    # 
    TkcRectangle.new(CANVAS, 0, 0, SIZE, SIZE, "width"=>0) {fill("white")}
    # 
    TkcLine.new(CANVAS, 0, SIZE/2, SIZE, SIZE/2) {fill("blue")}
    TkcLine.new(CANVAS, SIZE/2, 0, SIZE/2, SIZE) {fill("blue")}
  end
  #  
  def TkDrawer.drawPoint(p)
    # 
    TkcOval.new(CANVAS, x(p) + 1, y(p) + 1, x(p) - 1, y(p) - 1) {fill("black")}
  end
  #  
  def TkDrawer.drawLine(p,q)
    TkcLine.new(CANVAS, x(p), y(p), x(q), y(q)) {fill("red")}    
  end
  #DRAWING TR
  def TkDrawer.drawTr(k,l,m)
    TkcLine.new(CANVAS, x(k), y(k), x(l), y(l)) {fill("green")}    
    TkcLine.new(CANVAS, x(k), y(k), x(m), y(m)) {fill("green")}  
    TkcLine.new(CANVAS, x(l), y(l), x(m), y(m)) {fill("green")}  
  end
  #  
  def TkDrawer.drawLines(points)
    for i in -1...points.size-1
      TkDrawer.drawLine(points[i], points[i+1])
    end
  end
  private
  #  
  def TkDrawer.x(p)
    SIZE/2 + SCALE*p.x
  end
  def TkDrawer.y(p)
    SIZE/2 - SCALE*p.y
  end
  #     
  SIZE   = 600; SCALE  = 50
  #    
  ROOT   = TkRoot.new{title "Convex"; geometry "#{600+5}x#{600+5}"}
  #   
  CANVAS = TkCanvas.new(ROOT, "height"=>SIZE, "width"=>SIZE)
end
